%define _disable_ld_no_undefined 1


%define fversion 2007f
%define soname c-client

%define major 0
%define libname %mklibname %{soname} %{major}
%define develname %mklibname -d %{soname}

Summary:	UW-IMAP C-CLIENT library
Name:		c-client
Version:	2007f
Release:	%mkrel 18
License:	Apache License
Group:		System/Servers
URL:		https://www.washington.edu/imap/
Source:		ftp://ftp.cac.washington.edu/mail/imap-%{fversion}.tar.gz
Source7:	flock.c
Source8:	Makefile.imap
Patch0: 	imap-2002e-ssl.patch
Patch1: 	imap-2007a-linux.diff
Patch3:		imap-2001a-disable-mbox.patch
Patch4:		imap-2001a-redhat.patch
Patch5: 	imap-2006c1-flock.diff
Patch9:		imap-2006c1-glibc-2.2.2.diff
Patch11:	imap-2006c1-krbpath.diff
Patch12:	imap-2001a-overflow.patch
Patch17:	imap-mail-spool-perms.diff
Patch21:	imap-2004a-shared.patch
Patch22:	imap-2002e-authmd5.patch
# (oe) the annotate patch is implemented upstream and needed by kolab2
Patch23:	imap-2006c1-annotate.diff
# (oe) https://www.gadgetwiz.com/software/hash_reset.html
Patch24:	imap-2004g-hash_reset.diff
Patch25:	imap-yes.diff
# From debian
Patch26:	1006_openssl1.1_autoverify.patch
# From alpine
Patch27:	alpine-CVE-2020-14929.patch
#Fix build for mga10
Patch28:	fixBuildgcc.patch
BuildRequires:	pkgconfig(openssl) >= 1.1

%description
The c-client library is a common API for accessing mailboxes developed at
the University of Washington. It is used mainly by php in %{_vendor}.

%package -n	%{libname}
Summary:	C-client mail access routines for IMAP and POP protocols
Group:		System/Libraries
Provides:	c-client = %{version}-%{release}

%description -n	%{libname}
The c-client library is a common API for accessing mailboxes developed at
the University of Washington. It is used mainly by php in %{_vendor}.

This package contains the shared c-client library.

%package -n	%{develname}
Summary:	Development files for the c-client library
Group:		Development/C
Requires:	%{libname} = %{version}
Obsoletes:	libc-client-php-devel
Obsoletes:	%{mklibname c-client-php -d 0}
Obsoletes:	imap-devel
Provides:	c-client-devel = %{version}-%{release}

%description -n	%{develname}
The c-client library is a common API for accessing mailboxes developed at
the University of Washington. It is used mainly by php in %{_vendor}.

This package contains development files for the c-client library.

%prep

%setup -q -n imap-%{version}

%patch -P0 -p0 -b .ssl
%patch -P1 -p0 -b .linux
%patch -P3 -p1 -b .mbox
%patch -P4 -p0 -b .redhat
%patch -P5 -p0 -b .flock
install -m 0644 %{SOURCE7} src/osdep/unix/flock.c
%patch -P9 -p1 -b .glibc

%patch -P12 -p0 -b .overflow
%patch -P17 -p0 -b .lock-warning
%patch -P21 -p0 -b .shared
%patch -P22 -p1 -b .authmd5
%patch -P23 -p1 -b .annotate
%patch -P24 -p1 -b .hash_reset
%patch -P25 -p0 -b .yes
%patch -P26 -p1 -b .openssl11
%patch -P27 -p2 -b .CVE-2020-14929
%patch -P28 -p1

%build
%serverbuild

touch ip6
export CFLAGS="${CFLAGS} -Wno-error=implicit-function-declaration -Wno-error=incompatible-pointer-types"
export CXXFLAGS="${CXXFLAGS} -Wno-error=implicit-function-declaration -Wno-error=incompatible-pointer-types"
export EXTRACFLAGS="$EXTRACFLAGS $CFLAGS -DDISABLE_POP_PROXY=1 -DIGNORE_LOCK_EACCES_ERRORS=1 -I%{_includedir}/openssl -D_GNU_SOURCE -Wno-error=implicit-function-declaration -Wno-error=incompatible-pointer-types"
export EXTRALDFLAGS="$EXTRALDFLAGS -L%{_libdir} %{ldflags}"

make RPM_OPT_FLAGS="$CFLAGS -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer -D_GNU_SOURCE -Wno-error=implicit-function-declaration -Wno-error=incompatible-pointer-types" slx \
	EXTRACFLAGS="$EXTRACFLAGS" \
	EXTRALDFLAGS="$EXTRALDFLAGS" \
	SSLDIR=%{_libdir}/ssl \
	SSLINCLUDE=%{_includedir}/openssl \
	SSLLIB=%{_libdir} \
	LOCKPGM=%{_sbindir}/mlock \
	SSLTYPE=unix \
	SHLIBBASE=%{soname} \
	SHLIBNAME=lib%{soname}.so.%{major} \
	BASECFLAGS="$CFLAGS -D_REENTRANT -DDIC -fPIC -fno-omit-frame-pointer -D_GNU_SOURCE -Wno-error=implicit-function-declaration -Wno-error=incompatible-pointer-types" \
	IP=6

mv -f c-client/c-client.a %{soname}.a
mv -f c-client/lib%{soname}.so.%{major} .

%install
# make some directories
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_includedir}/imap

# install headers
install -m0644 c-client/*.h %{buildroot}%{_includedir}/imap/
install -m0644 src/osdep/tops-20/shortsym.h %{buildroot}%{_includedir}/imap/
install -m0644 src/osdep/tops-20/linkage.c %{buildroot}%{_includedir}/imap/

install -m0755 lib%{soname}.so.%{major} %{buildroot}%{_libdir}/
ln -snf lib%{soname}.so.%{major} %{buildroot}%{_libdir}/lib%{soname}.so
install -m0644 %{soname}.a %{buildroot}%{_libdir}/lib%{soname}.a



%files -n %{libname}
%{_libdir}/lib%{soname}.so.%{major}

%files -n %{develname}
%{_includedir}/imap
%{_libdir}/lib%{soname}.a
%{_libdir}/lib%{soname}.so




%changelog
* Sat Dec 21 2024 pterjan <pterjan> 2007f-18.mga10
+ Revision: 2127139
- Rebuild for patchN deprecation

* Sat Jul 27 2024 mokraemer <mokraemer> 2007f-17.mga10
+ Revision: 2082654
- added a fix to build

* Thu Mar 17 2022 umeabot <umeabot> 2007f-17.mga9
+ Revision: 1796543
- Mageia 9 Mass Rebuild

* Sat Oct 02 2021 wally <wally> 2007f-16.mga9
+ Revision: 1747787
- rebuild for openssl 3.0.0

* Sun Dec 27 2020 luigiwalser <luigiwalser> 2007f-15.mga8
+ Revision: 1664279
- add patch from alpine to fix CVE-2020-14929

* Sat Feb 15 2020 umeabot <umeabot> 2007f-14.mga8
+ Revision: 1523956
- Mageia 8 Mass Rebuild

* Sun Mar 17 2019 daviddavid <daviddavid> 2007f-13.mga7
+ Revision: 1378186
- add debian patch to build against openssl 1.1

* Sat Sep 22 2018 umeabot <umeabot> 2007f-12.mga7
+ Revision: 1295775
- Mageia 7 Mass Rebuild

* Wed Nov 22 2017 tv <tv> 2007f-11.mga7
+ Revision: 1178662
- rebuild for new openssl

* Mon Sep 25 2017 joequant <joequant> 2007f-10.mga7
+ Revision: 1159776
- change build requires
- build with compat-openssl10
- rebuild with new toolchain

* Wed Mar 02 2016 umeabot <umeabot> 2007f-8.mga6
+ Revision: 983178
- Rebuild for openssl

* Mon Feb 08 2016 umeabot <umeabot> 2007f-7.mga6
+ Revision: 944308
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 2007f-6.mga5
+ Revision: 750768
- Second Mageia 5 Mass Rebuild

* Thu Sep 18 2014 umeabot <umeabot> 2007f-5.mga5
+ Revision: 693548
- Rebuild to fix library dependencies

* Tue Sep 16 2014 umeabot <umeabot> 2007f-4.mga5
+ Revision: 678269
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 2007f-3.mga4
+ Revision: 503278
- Mageia 4 Mass Rebuild

* Fri Jan 11 2013 umeabot <umeabot> 2007f-2.mga3
+ Revision: 347280
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Sep 07 2011 tv <tv> 2007f-1.mga2
+ Revision: 140278
- rediff patch
- new release

* Sat May 21 2011 ahmad <ahmad> 2007e-6.mga1
+ Revision: 100007
- Replace a reference to Mandriva with Mageia

* Fri Jan 14 2011 mikala <mikala> 2007e-5.mga1
+ Revision: 17693
- Drop mdk macros
- imported package c-client

